class Base
  class << self
    private

    def request_post(path, params = {})
      uri = URI.parse(path.to_s)
      header = { 'Content-Type' => 'application/json' }

      http = Net::HTTP.new(uri.host, uri.port)
      http.use_ssl = (uri.scheme == 'https')
      request = Net::HTTP::Post.new(uri.request_uri, header)
      request.body = params.to_json
      res = http.request(request)

      JSON.parse(res.body)
    end

    def request_get(path, _params = {})
      url = URI.join(path)
      res = Net::HTTP.get_response url

      JSON.parse(res.body)
    end
  end
end
