module Teachable
  module Configuration
    DEFAULT_API_TOKEN = nil
    DEFAULT_USER_EMAIL = 'example@example.example'.freeze
    VALID_CONFIG = %i[user_token user_email].freeze

    attr_accessor *VALID_CONFIG

    def self.extended(base)
      base.reset
    end

    def reset
      self.user_token = DEFAULT_API_TOKEN
      self.user_email = DEFAULT_USER_EMAIL
    end

    def configure
      yield self
    end
  end
end
