module Teachable
  class Order < Base
    class << self
      def orders
        request_get("https://fast-bayou-75985.herokuapp.com/api/orders.json?user_email=#{Teachable.user_email}&user_token=#{Teachable.user_token}")
      end

      def create(params = {})
        request_post("https://fast-bayou-75985.herokuapp.com/api/orders.json?user_email=#{Teachable.user_email}&user_token=#{Teachable.user_token}", order: { total: params[:total], total_quantity: params[:total_quantity], email: Teachable.user_email, special_instructions: params[:special_instructions] })
      end

      def destroy(params = {})
        request_delete("https://fast-bayou-75985.herokuapp.com/api/orders/#{params[:id]}.json?user_email=#{Teachable.user_email}&user_token=#{Teachable.user_token}")
      end

      private

      def request_delete(path, _params = {})
        uri = URI.parse(path.to_s)
        http = Net::HTTP.new(uri.host, uri.port)
        http.use_ssl = (uri.scheme == 'https')
        request = Net::HTTP::Delete.new(uri.request_uri)
        res = http.request(request)
        res.code == '204' ? 'Order was deleted' : "You missed argument 'id' or this order doesn't exist"
      end
    end
  end
end
